//-----------------------------------------------------------------------------
// Interface.cpp
//-----------------------------------------------------------------------------
// Copyright 2012 Cristiano Lino Fontana
//
// This file is part of Girino.
//
//	Girino is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	Girino is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with Girino.  If not, see <http://www.gnu.org/licenses/>.
//
//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------

//include "Girino.h"
#include "Arduino_Fast_Oscilloscope.h"

int inPin2 = 2;
//-----------------------------------------------------------------------------
void error (void) {
	digitalWrite( errorPin, HIGH );
	delay( 500 );
	digitalWrite( errorPin, LOW );
	delay( 250 );
	digitalWrite( errorPin, HIGH );
	delay( 500 );
	digitalWrite( errorPin, LOW );
}

//-----------------------------------------------------------------------------
// fillBuffer
//-----------------------------------------------------------------------------
// Fills the given buffer with bufferSize chars from a Serial object

void fillBuffer( char *buffer, byte bufferSize, HardwareSerial::HardwareSerial* serial )
{
	// Clean buffer
	memset( (void *)buffer, '\0', sizeof(char) * bufferSize );

	//dprint(serial->available());
	
	byte limit = ( bufferSize < serial->available() ) ? bufferSize : serial->available();

	//dprint(serial->available());
	//dprint(bufferSize);
	//dprint(limit);

	// Fill buffer
	for ( byte i = 0; i < limit; i++ ) {
		//dprint(serial->available());
		//dprint(i);
		//dprint(buffer);

		buffer[i] = serial->read();
	}
}

void printStatus( void )
{
	Serial.print("Buffer size: ");
	Serial.println(ADCBUFFERSIZE);
	Serial.print("Baud rate: ");
	Serial.println(BAUDRATE);
	Serial.print("Wait duration: ");
	Serial.println(waitDuration);
	Serial.print("Prescaler: ");
	Serial.println(prescaler);
	Serial.print("Trigger event: ");
	Serial.println(triggerEvent);
	Serial.print("Threshold: ");
	Serial.println(threshold);
}

void EPT_USB_Write( uint8_t* ADCBuffer, uint16_t DataBufferSize)
{
     uint16_t  index;
     uint8_t   SendBufferHigh;
     uint8_t   SendBufferLow;
     uint16_t  TempBuffer = 500;
     uint16_t  StopIndexTimeShift = 64;
     uint16_t  ADCIndex=0;
     uint8_t   FifoAFull=0;
     
	
    ADCIndex = (TriggerCount);//-StopIndexTimeShift);
    for(index = 0; index < TempBuffer; index++)
     //for(index = ((TriggerCount-StopIndexTimeShift) % ADCBUFFERSIZE); index < ((TriggerCount-StopIndexTimeShift + TempBuffer) % ADCBUFFERSIZE); index++)
     //for(index = (ADCCounter - waitDuration); index < (ADCCounter); index++)
     //for(index = TriggerCount; index < (uint16_t)(TriggerCount + TempBuffer); index++)
     {

       //Test Data, Send a count to the PC
        //if(ADCTempCount < 256)
        //     ADCTempCount++;
        //else
        //     ADCTempCount = 0;
             
        // SendBufferHigh = (ADCTempCount & 0xfc)>>2;
        // SendBufferLow = (ADCTempCount & 0x03)<<3;    
          
           
         //Write the top six bits of the sample to PORTB  
         SendBufferHigh = (ADCBuffer[ADCIndex] & 0xfc)>>2;
         SendBufferLow = (ADCBuffer[ADCIndex] & 0x03)<<3;

          //Set the PORTB pins equal to the SendBufferHigh
          //Also set bit 6 high to indicate to the UnoProLogic
          //that data is transmitted
          PORTB = SendBufferHigh;

          //Set the PORTC pins equal to the SendBufferLow
          PORTC = SendBufferLow;

          //Assert the Write Enable   
          //PORTC = B00100010 | SendBufferLow;        
          //PORTC = B00100010 | SendBufferLow;        
          PORTC = B00100010 | SendBufferLow;        
          //De-assert the Write Enable   
          PORTC = B00000010 | SendBufferLow;
         //delay(10);
          
          if(ADCIndex < ADCBUFFERSIZE)
          {
             ADCIndex++; 
          }
          else
          {
             ADCIndex = 0;
          }
          
          //FifoAFull = B00000100 & PORTD;
          FifoAFull = digitalRead(inPin2);
          //while(FifoAFull)
          while(1)
          {
             //FifoAFull = B00000100 & PORTD;
             FifoAFull = digitalRead(inPin2);
             if(!FifoAFull)
                break;
          }

       }
          //Assert the End of Buffer Signal   
          //PORTC = B00000100;
          PORTC = B00000100;
          PORTC = B00000000;
          //delay(200);

}
