#include "EPT_SGTool.h"


// include the SPI library
#include <SPI.h>

//Include the I2C Library
#include <Wire.h>

//Declare some int variables for use in the Loop()
int Channel;
int LoopCount;
int TemperatureValue;

//Declare a Buffer for storing the ADC samples
int ChannelBuffer1[500] = {0};


void setup() 
{

  // join i2c bus (address optional for master)
  Wire.begin(); 
  
  // Set the Analog 0 signal as an input
  pinMode (0, INPUT);
  
  LoopCount = 0;
  Channel = 0;
  TemperatureValue = 0;
  
  //Initialize the Serial Graph Tool
  EPT_SGToolInit();
  

}

void loop() 
{
  //Set the LoopCount to zero
  LoopCount = 0;
  
  //Begin transmit to device #144 (0x90)
  Wire.beginTransmission(72); 

  // sets register pointer to the command register (0x00)
  Wire.write(0x00);        

  // stop transmitting 
  Wire.endTransmission(); 

  //Send request 2 bytes from slave device #34
  Wire.requestFrom(72, 2);    

  // if two bytes were received
  if(2 <= Wire.available())    
  {
    // receive high byte 
    TemperatureValue = Wire.read()<<4;  
    //Read lower byte 
    TemperatureValue |= Wire.read()>>4;
    //Send to ChannelBuffer
    ChannelBuffer1[LoopCount++] = TemperatureValue;    
   
    //Write the block of data to the Serial Graph Tool
    EPT_SGToolWriteBlockData(ChannelBuffer1, LoopCount, Channel, TEN_BIT_DATA);

    //Send end of frame so the SGTool will plot the data
    EPT_SGToolFrameEnd();
  
  }

  
  delay(500);
  
}

