﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace HyperSerialPort
{
    public partial class frmSendCharactersForm : Form
    {
        public frmSendCharactersForm()
        {
           InitializeComponent();

            //Remember the previous string and timer interval, then
            //display it in the text boxes
           textBoxSendChar.Text = frm.SendCharactersForm_SendCharString;
           textBoxSendTimer.Text = frm.SendCharactersForm_SendTimerInterval.ToString();

            //Set the start and stop buttons to enabled and disabled respectively
           btnSendCharTest.Enabled = true;
           btnStopSendCharTest.Enabled = false;
        }

        //creating object of parent to access shared variable  
        HyperSerialPort frm = new HyperSerialPort();
         
        private void textBoxSendChar_TextChanged(object sender, EventArgs e)
        {
            frm.SendCharactersForm_SendCharString = textBoxSendChar.Text;
        }

        private void textBoxSendTimer_TextChanged(object sender, EventArgs e)
        {
            if (textBoxSendTimer.Text == "")
                frm.SendCharactersForm_SendTimerInterval = 0;
            else
                frm.SendCharactersForm_SendTimerInterval = Int32.Parse(textBoxSendTimer.Text);

        }

        private void btnSendCharTest_Click(object sender, EventArgs e)
        {
            if( radioBtnSec.Checked )
            {
                frm.SendCharactersForm_millisecondTimerFlag = true;
                frm.SendCharactersForm_SendTimerInterval = frm.SendCharactersForm_SendTimerInterval * 1000;
                frm.SendCharactersForm_SendCharTest = true;
            }
            else if( radioBtnMilli.Checked )
            {
                if (frm.SendCharactersForm_SendTimerInterval > 15)
                    frm.SendCharactersForm_millisecondTimerFlag = true;
                else
                {
                    frm.SendCharactersForm_millisecondTimerFlag = false;
                    frm.SendCharactersForm_SendTimerInterval = frm.SendCharactersForm_SendTimerInterval * 1000;
                }

                frm.SendCharactersForm_SendCharTest = true;
            }
            else if( radioBtnMicro.Checked )
            {
                frm.SendCharactersForm_millisecondTimerFlag = false;
                frm.SendCharactersForm_SendCharTest = true;
            }

            if(radioButtonOneShot.Checked)
                 frm.SendCharactersForm_SendCharOneShot = true;
            else
                frm.SendCharactersForm_SendCharOneShot = false;
            if(radioButtonReptitive.Checked)
                 frm.SendCharactersForm_SendCharRepetitive = true;
            else
                frm.SendCharactersForm_SendCharRepetitive = false;
            if(radioBtnIncrement7Bit.Checked)
                 frm.SendCharactersForm_SendCharIncrement7Bit = true;
            else
                frm.SendCharactersForm_SendCharIncrement7Bit = false;
            if (radioBtnIncrementByte.Checked)
                frm.SendCharactersForm_SendCharIncrementByte = true;
            else
                frm.SendCharactersForm_SendCharIncrementByte = false;

            if (!frm.SendCharactersForm_SendCharOneShot)
            {
                btnSendCharTest.Enabled = false;
                btnStopSendCharTest.Enabled = true;
            }
            else
            {
                btnSendCharTest.Enabled = true;
                btnStopSendCharTest.Enabled = true;
            }

            frm.SendCharTestStart();
        }

        private void btnStopSendCharTest_Click(object sender, EventArgs e)
        {
            frm.SendCharactersForm_SendCharTest = false;
            frm.SendCharStopMillisecondTimer();
            frm.SendCharStopMicroTimer();

            if (!frm.SendCharactersForm_SendCharOneShot)
            {
                btnSendCharTest.Enabled = true;
                btnStopSendCharTest.Enabled = false;
            }
            else
            {
                btnSendCharTest.Enabled = true;
                btnStopSendCharTest.Enabled = true;
            }
        }
        
        private void btnOk_Click(object sender, EventArgs e)
        {
            frm.SendCharStopSerialPort1();
            frm.SendCharactersForm_SendCharTest = false;
            frm.SendCharStopMillisecondTimer();
            Thread.Sleep(500);
            //frm.OpenSerialPort1(); 
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            frm.SendCharStopSerialPort1();
            frm.SendCharactersForm_SendCharTest = false;
            frm.SendCharStopMillisecondTimer();
            Thread.Sleep(1000);
            //frm.OpenSerialPort1(); 
            this.Close();
        }

 
    }
}
